diff --git a/include/nng/nng.h b/include/nng/nng.h
index 6f5fdd45..3e70bc8f 100644
--- a/include/nng/nng.h
+++ b/include/nng/nng.h
@@ -761,10 +761,8 @@ NNG_DECL nng_dialer   nng_pipe_dialer(nng_pipe);
 NNG_DECL nng_listener nng_pipe_listener(nng_pipe);
 
 // Flags.
-enum nng_flag_enum {
-	NNG_FLAG_ALLOC    = 1, // Recv to allocate receive buffer.
-	NNG_FLAG_NONBLOCK = 2  // Non-blocking operations.
-};
+#define NNG_FLAG_ALLOC 1u // Recv to allocate receive buffer
+#define NNG_FLAG_NONBLOCK 2u // Non-blocking operations
 
 // Options.
 #define NNG_OPT_SOCKNAME "socket-name"
diff --git a/src/core/dialer.c b/src/core/dialer.c
index fe9cb92f..442454a6 100644
--- a/src/core/dialer.c
+++ b/src/core/dialer.c
@@ -20,21 +20,17 @@ static void dialer_connect_start(nni_dialer *);
 static void dialer_connect_cb(void *);
 static void dialer_timer_cb(void *);
 
-static nni_idhash *dialers;
-static nni_mtx     dialers_lk;
+static nni_idhash dialers;
+static nni_mtx    dialers_lk;
 
 #define BUMP_STAT(x) nni_stat_inc_atomic(x, 1)
 
 int
 nni_dialer_sys_init(void)
 {
-	int rv;
-
-	if ((rv = nni_idhash_init(&dialers)) != 0) {
-		return (rv);
-	}
+	nni_idhash_init_inline(&dialers);
 	nni_mtx_init(&dialers_lk);
-	nni_idhash_set_limits(dialers, 1, 0x7fffffff, 1);
+	nni_idhash_set_limits(&dialers, 1, 0x7fffffff, 1);
 
 	return (0);
 }
@@ -44,8 +40,7 @@ nni_dialer_sys_fini(void)
 {
 	nni_reap_drain();
 	nni_mtx_fini(&dialers_lk);
-	nni_idhash_fini(dialers);
-	dialers = NULL;
+	nni_idhash_fini_inline(&dialers);
 }
 
 uint32_t
@@ -57,11 +52,11 @@ nni_dialer_id(nni_dialer *d)
 void
 nni_dialer_destroy(nni_dialer *d)
 {
-	nni_aio_stop(d->d_con_aio);
-	nni_aio_stop(d->d_tmo_aio);
+	nni_aio_stop(&d->d_con_aio);
+	nni_aio_stop(&d->d_tmo_aio);
 
-	nni_aio_free(d->d_con_aio);
-	nni_aio_free(d->d_tmo_aio);
+	nni_aio_fini(&d->d_con_aio);
+	nni_aio_fini(&d->d_tmo_aio);
 
 	if (d->d_data != NULL) {
 		d->d_ops.d_fini(d->d_data);
@@ -204,11 +199,18 @@ nni_dialer_create(nni_dialer **dp, nni_sock *s, const char *urlstr)
 	nni_mtx_init(&d->d_mtx);
 
 	dialer_stats_init(d);
-	if (((rv = nni_aio_alloc(&d->d_con_aio, dialer_connect_cb, d)) != 0) ||
-	    ((rv = nni_aio_alloc(&d->d_tmo_aio, dialer_timer_cb, d)) != 0) ||
-	    ((rv = d->d_ops.d_init(&d->d_data, url, d)) != 0) ||
-	    ((rv = nni_idhash_alloc32(dialers, &d->d_id, d)) != 0) ||
+	nni_aio_init(&d->d_con_aio, dialer_connect_cb, d);
+	nni_aio_init(&d->d_tmo_aio, dialer_timer_cb, d);
+
+	nni_mtx_lock(&dialers_lk);
+	rv = nni_idhash_alloc32(&dialers, &d->d_id, d);
+	nni_mtx_unlock(&dialers_lk);
+
+	if ((rv != 0) || ((rv = d->d_ops.d_init(&d->d_data, url, d)) != 0) ||
 	    ((rv = nni_sock_add_dialer(s, d)) != 0)) {
+		nni_mtx_lock(&dialers_lk);
+		nni_idhash_remove(&dialers, d->d_id);
+		nni_mtx_unlock(&dialers_lk);
 		nni_dialer_destroy(d);
 		return (rv);
 	}
@@ -232,13 +234,9 @@ nni_dialer_find(nni_dialer **dp, uint32_t id)
 	}
 
 	nni_mtx_lock(&dialers_lk);
-	if ((rv = nni_idhash_find(dialers, id, (void **) &d)) == 0) {
-		if (d->d_closed) {
-			rv = NNG_ECLOSED;
-		} else {
-			d->d_refcnt++;
-			*dp = d;
-		}
+	if ((rv = nni_idhash_find(&dialers, id, (void **) &d)) == 0) {
+		d->d_refcnt++;
+		*dp = d;
 	}
 	nni_mtx_unlock(&dialers_lk);
 	return (rv);
@@ -280,14 +278,9 @@ nni_dialer_close_rele(nni_dialer *d)
 		return;
 	}
 	d->d_closed = true;
+	nni_idhash_remove(&dialers, d->d_id);
 	nni_mtx_unlock(&dialers_lk);
 
-	// Remove us from the table so we cannot be found.
-	// This is done fairly early in the teardown process.
-	// If we're here, either the socket or the listener has been
-	// closed at the user request, so there would be a race anyway.
-	nni_idhash_remove(dialers, d->d_id);
-
 	nni_dialer_rele(d);
 }
 
@@ -301,14 +294,9 @@ nni_dialer_close(nni_dialer *d)
 		return;
 	}
 	d->d_closed = true;
+	nni_idhash_remove(&dialers, d->d_id);
 	nni_mtx_unlock(&dialers_lk);
 
-	// Remove us from the table so we cannot be found.
-	// This is done fairly early in the teardown process.
-	// If we're here, either the socket or the listener has been
-	// closed at the user request, so there would be a race anyway.
-	nni_idhash_remove(dialers, d->d_id);
-
 	nni_dialer_shutdown(d);
 
 	nni_dialer_rele(d);
@@ -317,10 +305,9 @@ nni_dialer_close(nni_dialer *d)
 static void
 dialer_timer_cb(void *arg)
 {
-	nni_dialer *d   = arg;
-	nni_aio *   aio = d->d_tmo_aio;
+	nni_dialer *d = arg;
 
-	if (nni_aio_result(aio) == 0) {
+	if (nni_aio_result(&d->d_tmo_aio) == 0) {
 		dialer_connect_start(d);
 	}
 }
@@ -329,7 +316,7 @@ static void
 dialer_connect_cb(void *arg)
 {
 	nni_dialer *d   = arg;
-	nni_aio *   aio = d->d_con_aio;
+	nni_aio *   aio = &d->d_con_aio;
 	nni_aio *   user_aio;
 	int         rv;
 
@@ -366,13 +353,11 @@ dialer_connect_cb(void *arg)
 static void
 dialer_connect_start(nni_dialer *d)
 {
-	nni_aio *aio = d->d_con_aio;
-
-	d->d_ops.d_connect(d->d_data, aio);
+	d->d_ops.d_connect(d->d_data, &d->d_con_aio);
 }
 
 int
-nni_dialer_start(nni_dialer *d, int flags)
+nni_dialer_start(nni_dialer *d, unsigned flags)
 {
 	int      rv = 0;
 	nni_aio *aio;
diff --git a/src/core/dialer.h b/src/core/dialer.h
index 200ad01d..df923209 100644
--- a/src/core/dialer.h
+++ b/src/core/dialer.h
@@ -1,5 +1,5 @@
 //
-// Copyright 2019 Staysail Systems, Inc. <info@staysail.tech>
+// Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
 // Copyright 2018 Capitar IT Group BV <info@capitar.com>
 // Copyright 2018 Devolutions <info@devolutions.net>
 //
@@ -20,7 +20,7 @@ extern void      nni_dialer_rele(nni_dialer *);
 extern uint32_t  nni_dialer_id(nni_dialer *);
 extern int       nni_dialer_create(nni_dialer **, nni_sock *, const char *);
 extern void      nni_dialer_close(nni_dialer *);
-extern int       nni_dialer_start(nni_dialer *, int);
+extern int       nni_dialer_start(nni_dialer *, unsigned);
 extern nni_sock *nni_dialer_sock(nni_dialer *);
 
 extern int nni_dialer_setopt(
diff --git a/src/core/idhash.c b/src/core/idhash.c
index 80613ce0..0d44dcdc 100644
--- a/src/core/idhash.c
+++ b/src/core/idhash.c
@@ -1,5 +1,5 @@
 //
-// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
+// Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
 // Copyright 2018 Capitar IT Group BV <info@capitar.com>
 //
 // This software is supplied under the terms of the MIT License, a
@@ -18,19 +18,6 @@ struct nni_idhash_entry {
 	uint32_t ihe_skips;
 };
 
-struct nni_idhash {
-	size_t            ih_cap;
-	size_t            ih_count;
-	size_t            ih_load;
-	size_t            ih_minload; // considers placeholders
-	size_t            ih_maxload;
-	uint64_t          ih_minval;
-	uint64_t          ih_maxval;
-	uint64_t          ih_dynval;
-	nni_idhash_entry *ih_entries;
-	nni_mtx           ih_mtx;
-};
-
 int
 nni_idhash_init(nni_idhash **hp)
 {
@@ -39,35 +26,46 @@ nni_idhash_init(nni_idhash **hp)
 	if ((h = NNI_ALLOC_STRUCT(h)) == NULL) {
 		return (NNG_ENOMEM);
 	}
-	nni_mtx_init(&h->ih_mtx);
-	h->ih_entries = NULL;
-	h->ih_count   = 0;
-	h->ih_load    = 0;
-	h->ih_cap     = 0;
-	h->ih_maxload = 0;
-	h->ih_minload = 0; // never shrink below this
-	h->ih_minval  = 0;
-	h->ih_maxval  = 0xffffffff;
-	h->ih_dynval  = 0;
+	nni_idhash_init_inline(h);
 	*hp           = h;
 	return (0);
 }
 
+void
+nni_idhash_init_inline(nni_idhash *h)
+{
+        h->ih_entries = NULL;
+        h->ih_count   = 0;
+        h->ih_load    = 0;
+        h->ih_cap     = 0;
+        h->ih_maxload = 0;
+        h->ih_minload = 0; // never shrink below this
+        h->ih_minval  = 0;
+        h->ih_maxval  = 0xffffffff;
+        h->ih_dynval  = 0;
+}
+
+
 void
 nni_idhash_fini(nni_idhash *h)
 {
 	if (h != NULL) {
-		if (h->ih_entries != NULL) {
-			NNI_FREE_STRUCTS(h->ih_entries, h->ih_cap);
-			h->ih_entries = NULL;
-			h->ih_cap = h->ih_count = 0;
-			h->ih_load = h->ih_minload = h->ih_maxload = 0;
-		}
-		nni_mtx_fini(&h->ih_mtx);
+		nni_idhash_fini_inline(h);
 		NNI_FREE_STRUCT(h);
 	}
 }
 
+void
+nni_idhash_fini_inline(nni_idhash *h)
+{
+        if (h->ih_entries != NULL) {
+                NNI_FREE_STRUCTS(h->ih_entries, h->ih_cap);
+                h->ih_entries = NULL;
+                h->ih_cap = h->ih_count = 0;
+                h->ih_load = h->ih_minload = h->ih_maxload = 0;
+        }
+}
+
 void
 nni_idhash_set_limits(
     nni_idhash *h, uint64_t minval, uint64_t maxval, uint64_t start)
@@ -79,14 +77,12 @@ nni_idhash_set_limits(
 		start = maxval;
 	}
 
-	nni_mtx_lock(&h->ih_mtx);
 	h->ih_minval = minval;
 	h->ih_maxval = maxval;
 	h->ih_dynval = start;
 	NNI_ASSERT(minval < maxval);
 	NNI_ASSERT(start >= minval);
 	NNI_ASSERT(start <= maxval);
-	nni_mtx_unlock(&h->ih_mtx);
 }
 
 // Inspired by Python dict implementation.  This probe will visit every
@@ -124,8 +120,8 @@ nni_hash_find_index(nni_idhash *h, uint64_t id)
 	return ((size_t) -1);
 }
 
-static int
-nni_hash_find(nni_idhash *h, uint64_t id, void **valp)
+int
+nni_idhash_find(nni_idhash *h, uint64_t id, void **valp)
 {
 	size_t index;
 	if ((index = nni_hash_find_index(h, id)) == (size_t) -1) {
@@ -135,17 +131,6 @@ nni_hash_find(nni_idhash *h, uint64_t id, void **valp)
 	return (0);
 }
 
-int
-nni_idhash_find(nni_idhash *h, uint64_t id, void **valp)
-{
-	int rv;
-
-	nni_mtx_lock(&h->ih_mtx);
-	rv = nni_hash_find(h, id, valp);
-	nni_mtx_unlock(&h->ih_mtx);
-	return (rv);
-}
-
 static int
 nni_hash_resize(nni_idhash *h)
 {
@@ -223,9 +208,7 @@ nni_idhash_remove(nni_idhash *h, uint64_t id)
 	size_t            srch;
 	nni_idhash_entry *ent;
 
-	nni_mtx_lock(&h->ih_mtx);
 	if ((index = nni_hash_find_index(h, id)) == (size_t) -1) {
-		nni_mtx_unlock(&h->ih_mtx);
 		return (NNG_ENOENT);
 	}
 
@@ -254,8 +237,6 @@ nni_idhash_remove(nni_idhash *h, uint64_t id)
 	// Shrink -- but it's ok if we can't.
 	(void) nni_hash_resize(h);
 
-	nni_mtx_unlock(&h->ih_mtx);
-
 	return (0);
 }
 
@@ -305,9 +286,7 @@ nni_idhash_insert(nni_idhash *h, uint64_t id, void *val)
 {
 	int rv;
 
-	nni_mtx_lock(&h->ih_mtx);
 	rv = nni_hash_insert(h, id, val);
-	nni_mtx_unlock(&h->ih_mtx);
 	return (rv);
 }
 
@@ -316,14 +295,11 @@ nni_idhash_alloc(nni_idhash *h, uint64_t *idp, void *val)
 {
 	uint64_t id;
 	int      rv;
-	nni_mtx_lock(&h->ih_mtx);
 
 	NNI_ASSERT(val != NULL);
 
 	if (h->ih_count > (h->ih_maxval - h->ih_minval)) {
 		// Really more like ENOSPC.. the table is filled to max.
-		nni_mtx_unlock(&h->ih_mtx);
-
 		return (NNG_ENOMEM);
 	}
 
@@ -343,8 +319,6 @@ nni_idhash_alloc(nni_idhash *h, uint64_t *idp, void *val)
 	if (rv == 0) {
 		*idp = id;
 	}
-	nni_mtx_unlock(&h->ih_mtx);
-
 	return (rv);
 }
 
diff --git a/src/core/idhash.h b/src/core/idhash.h
index 5b9ed593..1de306a1 100644
--- a/src/core/idhash.h
+++ b/src/core/idhash.h
@@ -1,5 +1,5 @@
 //
-// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
+// Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
 // Copyright 2018 Capitar IT Group BV <info@capitar.com>
 //
 // This software is supplied under the terms of the MIT License, a
@@ -26,6 +26,23 @@
 typedef struct nni_idhash       nni_idhash;
 typedef struct nni_idhash_entry nni_idhash_entry;
 
+// NB: These details are entirely private to the hash implementation.
+// They are provided here to facilitate inlining in structures.
+struct nni_idhash {
+        size_t            ih_cap;
+        size_t            ih_count;
+        size_t            ih_load;
+        size_t            ih_minload; // considers placeholders
+        size_t            ih_maxload;
+        uint64_t          ih_minval;
+        uint64_t          ih_maxval;
+        uint64_t          ih_dynval;
+        nni_idhash_entry *ih_entries;
+};
+
+extern void  nni_idhash_init_inline(nni_idhash *);
+extern void  nni_idhash_fini_inline(nni_idhash *);
+
 extern int  nni_idhash_init(nni_idhash **);
 extern void nni_idhash_fini(nni_idhash *);
 extern void nni_idhash_set_limits(nni_idhash *, uint64_t, uint64_t, uint64_t);
diff --git a/src/core/listener.c b/src/core/listener.c
index 1fde6e36..8195d6f2 100644
--- a/src/core/listener.c
+++ b/src/core/listener.c
@@ -1,5 +1,5 @@
 //
-// Copyright 2019 Staysail Systems, Inc. <info@staysail.tech>
+// Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
 // Copyright 2018 Capitar IT Group BV <info@capitar.com>
 // Copyright 2018 Devolutions <info@devolutions.net>
 //
@@ -21,21 +21,17 @@ static void listener_accept_start(nni_listener *);
 static void listener_accept_cb(void *);
 static void listener_timer_cb(void *);
 
-static nni_idhash *listeners;
-static nni_mtx     listeners_lk;
+static nni_idhash listeners;
+static nni_mtx    listeners_lk;
 
 #define BUMP_STAT(x) nni_stat_inc_atomic(x, 1)
 
 int
 nni_listener_sys_init(void)
 {
-	int rv;
-
-	if ((rv = nni_idhash_init(&listeners)) != 0) {
-		return (rv);
-	}
+	nni_idhash_init_inline(&listeners);
 	nni_mtx_init(&listeners_lk);
-	nni_idhash_set_limits(listeners, 1, 0x7fffffff, 1);
+	nni_idhash_set_limits(&listeners, 1, 0x7fffffff, 1);
 
 	return (0);
 }
@@ -45,8 +41,7 @@ nni_listener_sys_fini(void)
 {
 	nni_reap_drain();
 	nni_mtx_fini(&listeners_lk);
-	nni_idhash_fini(listeners);
-	listeners = NULL;
+	nni_idhash_fini_inline(&listeners);
 }
 
 uint32_t
@@ -58,11 +53,11 @@ nni_listener_id(nni_listener *l)
 void
 nni_listener_destroy(nni_listener *l)
 {
-	nni_aio_stop(l->l_acc_aio);
-	nni_aio_stop(l->l_tmo_aio);
+	nni_aio_stop(&l->l_acc_aio);
+	nni_aio_stop(&l->l_tmo_aio);
 
-	nni_aio_free(l->l_acc_aio);
-	nni_aio_free(l->l_tmo_aio);
+	nni_aio_fini(&l->l_acc_aio);
+	nni_aio_fini(&l->l_tmo_aio);
 
 	if (l->l_data != NULL) {
 		l->l_ops.l_fini(l->l_data);
@@ -196,11 +191,18 @@ nni_listener_create(nni_listener **lp, nni_sock *s, const char *url_str)
 	NNI_LIST_INIT(&l->l_pipes, nni_pipe, p_ep_node);
 	listener_stats_init(l);
 
-	if (((rv = nni_aio_alloc(&l->l_acc_aio, listener_accept_cb, l)) != 0) ||
-	    ((rv = nni_aio_alloc(&l->l_tmo_aio, listener_timer_cb, l)) != 0) ||
-	    ((rv = l->l_ops.l_init(&l->l_data, url, l)) != 0) ||
-	    ((rv = nni_idhash_alloc32(listeners, &l->l_id, l)) != 0) ||
+	nni_aio_init(&l->l_acc_aio, listener_accept_cb, l);
+	nni_aio_init(&l->l_tmo_aio, listener_timer_cb, l);
+
+	nni_mtx_lock(&listeners_lk);
+	rv = nni_idhash_alloc32(&listeners, &l->l_id, l);
+	nni_mtx_unlock(&listeners_lk);
+
+	if ((rv != 0) || ((rv = l->l_ops.l_init(&l->l_data, url, l)) != 0) ||
 	    ((rv = nni_sock_add_listener(s, l)) != 0)) {
+		nni_mtx_lock(&listeners_lk);
+		nni_idhash_remove(&listeners, l->l_id);
+		nni_mtx_unlock(&listeners_lk);
 		nni_listener_destroy(l);
 		return (rv);
 	}
@@ -226,13 +228,9 @@ nni_listener_find(nni_listener **lp, uint32_t id)
 	}
 
 	nni_mtx_lock(&listeners_lk);
-	if ((rv = nni_idhash_find(listeners, id, (void **) &l)) == 0) {
-		if (l->l_closed) {
-			rv = NNG_ECLOSED;
-		} else {
-			l->l_refcnt++;
-			*lp = l;
-		}
+	if ((rv = nni_idhash_find(&listeners, id, (void **) &l)) == 0) {
+		l->l_refcnt++;
+		*lp = l;
 	}
 	nni_mtx_unlock(&listeners_lk);
 	return (rv);
@@ -274,14 +272,9 @@ nni_listener_close(nni_listener *l)
 		return;
 	}
 	l->l_closed = true;
+	nni_idhash_remove(&listeners, l->l_id);
 	nni_mtx_unlock(&listeners_lk);
 
-	// Remove us from the table so we cannot be found.
-	// This is done fairly early in the teardown process.
-	// If we're here, either the socket or the listener has been
-	// closed at the user request, so there would be a race anyway.
-	nni_idhash_remove(listeners, l->l_id);
-
 	nni_listener_shutdown(l);
 
 	nni_listener_rele(l); // This will trigger a reap if id count is zero.
@@ -298,13 +291,9 @@ nni_listener_close_rele(nni_listener *l)
 		return;
 	}
 	l->l_closed = true;
+	nni_idhash_remove(&listeners, l->l_id);
 	nni_mtx_unlock(&listeners_lk);
 
-	// Remove us from the table so we cannot be found.
-	// This is done fairly early in the teardown process.
-	// If we're here, either the socket or the listener has been
-	// closed at the user request, so there would be a race anyway.
-	nni_idhash_remove(listeners, l->l_id);
 	nni_listener_rele(l); // This will trigger a reap if id count is zero.
 }
 
@@ -312,9 +301,8 @@ static void
 listener_timer_cb(void *arg)
 {
 	nni_listener *l   = arg;
-	nni_aio *     aio = l->l_tmo_aio;
 
-	if (nni_aio_result(aio) == 0) {
+	if (nni_aio_result(&l->l_tmo_aio) == 0) {
 		listener_accept_start(l);
 	}
 }
@@ -323,8 +311,8 @@ static void
 listener_accept_cb(void *arg)
 {
 	nni_listener *l   = arg;
-	nni_aio *     aio = l->l_acc_aio;
-	int rv;
+	nni_aio *     aio = &l->l_acc_aio;
+	int           rv;
 
 	switch ((rv = nni_aio_result(aio))) {
 	case 0:
@@ -350,7 +338,7 @@ listener_accept_cb(void *arg)
 		// by not thrashing we give the system a chance to
 		// recover.  100 ms is enough to cool down.
 		nni_listener_bump_error(l, rv);
-		nni_sleep_aio(100, l->l_tmo_aio);
+		nni_sleep_aio(100, &l->l_tmo_aio);
 		break;
 	}
 }
@@ -358,16 +346,14 @@ listener_accept_cb(void *arg)
 static void
 listener_accept_start(nni_listener *l)
 {
-	nni_aio *aio = l->l_acc_aio;
-
 	// Call with the listener lock held.
-	l->l_ops.l_accept(l->l_data, aio);
+	l->l_ops.l_accept(l->l_data, &l->l_acc_aio);
 }
 
 int
 nni_listener_start(nni_listener *l, int flags)
 {
-	int rv = 0;
+	int rv;
 	NNI_ARG_UNUSED(flags);
 
 	if (nni_atomic_flag_test_and_set(&l->l_started)) {
diff --git a/src/core/pipe.c b/src/core/pipe.c
index 4076b62c..3799de1c 100644
--- a/src/core/pipe.c
+++ b/src/core/pipe.c
@@ -13,26 +13,20 @@
 #include "sockimpl.h"
 
 #include <stdio.h>
-#include <string.h>
 
 // This file contains functions relating to pipes.
 //
 // Operations on pipes (to the transport) are generally blocking operations,
 // performed in the context of the protocol.
 
-static nni_idhash *nni_pipes;
-static nni_mtx     nni_pipe_lk;
+static nni_idhash pipes;
+static nni_mtx    pipes_lk;
 
 int
 nni_pipe_sys_init(void)
 {
-	int rv;
-
-	nni_mtx_init(&nni_pipe_lk);
-
-	if ((rv = nni_idhash_init(&nni_pipes)) != 0) {
-		return (rv);
-	}
+	nni_mtx_init(&pipes_lk);
+	nni_idhash_init_inline(&pipes);
 
 	// Note that pipes have their own namespace.  ID hash will
 	// guarantee the that the first value is reasonable (non-zero),
@@ -40,7 +34,7 @@ nni_pipe_sys_init(void)
 	// value "1" has a bias -- its roughly twice as likely to be
 	// chosen as any other value.  This does not mater.)
 	nni_idhash_set_limits(
-	    nni_pipes, 1, 0x7fffffff, nni_random() & 0x7fffffffu);
+	    &pipes, 1, 0x7fffffff, nni_random() & 0x7fffffffu);
 
 	return (0);
 }
@@ -49,11 +43,8 @@ void
 nni_pipe_sys_fini(void)
 {
 	nni_reap_drain();
-	nni_mtx_fini(&nni_pipe_lk);
-	if (nni_pipes != NULL) {
-		nni_idhash_fini(nni_pipes);
-		nni_pipes = NULL;
-	}
+	nni_mtx_fini(&pipes_lk);
+	nni_idhash_fini_inline(&pipes);
 }
 
 static void
@@ -67,15 +58,15 @@ pipe_destroy(nni_pipe *p)
 
 	// Make sure any unlocked holders are done with this.
 	// This happens during initialization for example.
-	nni_mtx_lock(&nni_pipe_lk);
+	nni_mtx_lock(&pipes_lk);
 	if (p->p_id != 0) {
-		nni_idhash_remove(nni_pipes, p->p_id);
+		nni_idhash_remove(&pipes, p->p_id);
 	}
 	// This wait guarantees that all callers are done with us.
 	while (p->p_refcnt != 0) {
 		nni_cv_wait(&p->p_cv);
 	}
-	nni_mtx_unlock(&nni_pipe_lk);
+	nni_mtx_unlock(&pipes_lk);
 
 	if (p->p_proto_data != NULL) {
 		p->p_proto_ops.pipe_stop(p->p_proto_data);
@@ -103,29 +94,29 @@ nni_pipe_find(nni_pipe **pp, uint32_t id)
 {
 	int       rv;
 	nni_pipe *p;
-	nni_mtx_lock(&nni_pipe_lk);
+	nni_mtx_lock(&pipes_lk);
 
 	// We don't care if the pipe is "closed".  End users only have
 	// access to the pipe in order to obtain properties (which may
 	// be retried during the post-close notification callback) or to
 	// close the pipe.
-	if ((rv = nni_idhash_find(nni_pipes, id, (void **) &p)) == 0) {
+	if ((rv = nni_idhash_find(&pipes, id, (void **) &p)) == 0) {
 		p->p_refcnt++;
 		*pp = p;
 	}
-	nni_mtx_unlock(&nni_pipe_lk);
+	nni_mtx_unlock(&pipes_lk);
 	return (rv);
 }
 
 void
 nni_pipe_rele(nni_pipe *p)
 {
-	nni_mtx_lock(&nni_pipe_lk);
+	nni_mtx_lock(&pipes_lk);
 	p->p_refcnt--;
 	if (p->p_refcnt == 0) {
 		nni_cv_wake(&p->p_cv);
 	}
-	nni_mtx_unlock(&nni_pipe_lk);
+	nni_mtx_unlock(&pipes_lk);
 }
 
 // nni_pipe_id returns the 32-bit pipe id, which can be used in backtraces.
@@ -188,9 +179,9 @@ pipe_create(nni_pipe **pp, nni_sock *sock, nni_tran *tran, void *tdata)
 	void *              sdata = nni_sock_proto_data(sock);
 	nni_proto_pipe_ops *pops  = nni_sock_proto_pipe_ops(sock);
 	nni_pipe_stats *    st;
-	size_t sz;
+	size_t              sz;
 
-	sz = NNI_ALIGN_UP(sizeof (*p)) + pops->pipe_size;
+	sz = NNI_ALIGN_UP(sizeof(*p)) + pops->pipe_size;
 
 	if ((p = nni_zalloc(sz)) == NULL) {
 		// In this case we just toss the pipe...
@@ -198,7 +189,7 @@ pipe_create(nni_pipe **pp, nni_sock *sock, nni_tran *tran, void *tdata)
 		return (NNG_ENOMEM);
 	}
 
-	p->p_size = sz;
+	p->p_size       = sz;
 	p->p_proto_data = p + 1;
 	p->p_tran_ops   = *tran->tran_pipe;
 	p->p_tran_data  = tdata;
@@ -214,13 +205,13 @@ pipe_create(nni_pipe **pp, nni_sock *sock, nni_tran *tran, void *tdata)
 	NNI_LIST_NODE_INIT(&p->p_ep_node);
 
 	nni_mtx_init(&p->p_mtx);
-	nni_cv_init(&p->p_cv, &nni_pipe_lk);
+	nni_cv_init(&p->p_cv, &pipes_lk);
 
-	nni_mtx_lock(&nni_pipe_lk);
-	if ((rv = nni_idhash_alloc32(nni_pipes, &p->p_id, p)) == 0) {
+	nni_mtx_lock(&pipes_lk);
+	if ((rv = nni_idhash_alloc32(&pipes, &p->p_id, p)) == 0) {
 		p->p_refcnt = 1;
 	}
-	nni_mtx_unlock(&nni_pipe_lk);
+	nni_mtx_unlock(&pipes_lk);
 
 	snprintf(st->s_scope, sizeof(st->s_scope), "pipe%u", p->p_id);
 
diff --git a/src/core/socket.c b/src/core/socket.c
index 6e3f14d0..13508721 100644
--- a/src/core/socket.c
+++ b/src/core/socket.c
@@ -16,10 +16,11 @@
 
 // Socket implementation.
 
-static nni_list    sock_list;
-static nni_idhash *sock_hash;
-static nni_mtx     sock_lk;
-static nni_idhash *ctx_hash;
+static nni_list   sock_list;
+static nni_idhash sock_hash;
+static nni_mtx    sock_lk;
+static nni_idhash ctx_hash;
+static bool       inited;
 
 struct nni_ctx {
 	nni_list_node     c_node;
@@ -117,7 +118,7 @@ static void listener_shutdown_locked(nni_listener *);
 #define SOCK(s) ((nni_sock *) (s))
 
 static int
-sock_get_fd(void *s, int flag, int *fdp)
+sock_get_fd(void *s, unsigned flag, int *fdp)
 {
 	int           rv;
 	nni_pollable *p;
@@ -374,7 +375,7 @@ nni_sock_find(nni_sock **sockp, uint32_t id)
 		return (rv);
 	}
 	nni_mtx_lock(&sock_lk);
-	if ((rv = nni_idhash_find(sock_hash, id, (void **) &s)) == 0) {
+	if ((rv = nni_idhash_find(&sock_hash, id, (void **) &s)) == 0) {
 		if (s->s_closed) {
 			rv = NNG_ECLOSED;
 		} else {
@@ -582,33 +583,24 @@ nni_sock_create(nni_sock **sp, const nni_proto *proto)
 int
 nni_sock_sys_init(void)
 {
-	int rv;
-
 	NNI_LIST_INIT(&sock_list, nni_sock, s_node);
 	nni_mtx_init(&sock_lk);
 
-	if (((rv = nni_idhash_init(&sock_hash)) != 0) ||
-	    ((rv = nni_idhash_init(&ctx_hash)) != 0)) {
-		nni_sock_sys_fini();
-		return (rv);
-	}
-	nni_idhash_set_limits(sock_hash, 1, 0x7fffffff, 1);
-	nni_idhash_set_limits(ctx_hash, 1, 0x7fffffff, 1);
+	nni_idhash_init_inline(&sock_hash);
+	nni_idhash_init_inline(&ctx_hash);
+	nni_idhash_set_limits(&sock_hash, 1, 0x7fffffff, 1);
+	nni_idhash_set_limits(&ctx_hash, 1, 0x7fffffff, 1);
+	inited = true;
 	return (0);
 }
 
 void
 nni_sock_sys_fini(void)
 {
-	if (sock_hash != NULL) {
-		nni_idhash_fini(sock_hash);
-		sock_hash = NULL;
-	}
-	if (ctx_hash != NULL) {
-		nni_idhash_fini(ctx_hash);
-		ctx_hash = NULL;
-	}
+	nni_idhash_fini_inline(&sock_hash);
+	nni_idhash_fini_inline(&ctx_hash);
 	nni_mtx_fini(&sock_lk);
+	inited = false;
 }
 
 int
@@ -628,7 +620,7 @@ nni_sock_open(nni_sock **sockp, const nni_proto *proto)
 	}
 
 	nni_mtx_lock(&sock_lk);
-	if (nni_idhash_alloc32(sock_hash, &s->s_id, s) != 0) {
+	if (nni_idhash_alloc32(&sock_hash, &s->s_id, s) != 0) {
 		sock_destroy(s);
 	} else {
 		nni_list_append(&sock_list, s);
@@ -691,7 +683,7 @@ nni_sock_shutdown(nni_sock *sock)
 		ctx->c_closed = true;
 		if (ctx->c_refcnt == 0) {
 			// No open operations.  So close it.
-			nni_idhash_remove(ctx_hash, ctx->c_id);
+			nni_idhash_remove(&ctx_hash, ctx->c_id);
 			nni_list_remove(&sock->s_ctxs, ctx);
 			nni_ctx_destroy(ctx);
 		}
@@ -790,7 +782,7 @@ nni_sock_close(nni_sock *s)
 		return;
 	}
 	s->s_closed = true;
-	nni_idhash_remove(sock_hash, s->s_id);
+	nni_idhash_remove(&sock_hash, s->s_id);
 
 	// We might have been removed from the list already, e.g. by
 	// nni_sock_closeall.  This is idempotent.
@@ -820,7 +812,7 @@ nni_sock_closeall(void)
 {
 	nni_sock *s;
 
-	if (sock_hash == NULL) {
+	if (!inited) {
 		return;
 	}
 	for (;;) {
@@ -1161,7 +1153,7 @@ nni_ctx_find(nni_ctx **ctxp, uint32_t id, bool closing)
 		return (rv);
 	}
 	nni_mtx_lock(&sock_lk);
-	if ((rv = nni_idhash_find(ctx_hash, id, (void **) &ctx)) == 0) {
+	if ((rv = nni_idhash_find(&ctx_hash, id, (void **) &ctx)) == 0) {
 		// We refuse a reference if either the socket is
 		// closed, or the context is closed.  (If the socket
 		// is closed, and we are only getting the reference so
@@ -1211,7 +1203,7 @@ nni_ctx_rele(nni_ctx *ctx)
 	// Remove us from the hash, so we can't be found any more.
 	// This allows our ID to be reused later, although the system
 	// tries to avoid ID reuse.
-	nni_idhash_remove(ctx_hash, ctx->c_id);
+	nni_idhash_remove(&ctx_hash, ctx->c_id);
 	nni_list_remove(&sock->s_ctxs, ctx);
 	if (sock->s_closed || sock->s_ctxwait) {
 		nni_cv_wake(&sock->s_close_cv);
@@ -1236,8 +1228,8 @@ nni_ctx_open(nni_ctx **ctxp, nni_sock *sock)
 	if ((ctx = nni_zalloc(sz)) == NULL) {
 		return (NNG_ENOMEM);
 	}
-	ctx->c_size = sz;
-	ctx->c_data = ctx + 1;
+	ctx->c_size     = sz;
+	ctx->c_data     = ctx + 1;
 	ctx->c_closed   = false;
 	ctx->c_refcnt   = 1; // Caller implicitly gets a reference.
 	ctx->c_sock     = sock;
@@ -1251,14 +1243,14 @@ nni_ctx_open(nni_ctx **ctxp, nni_sock *sock)
 		nni_free(ctx, ctx->c_size);
 		return (NNG_ECLOSED);
 	}
-	if ((rv = nni_idhash_alloc32(ctx_hash, &ctx->c_id, ctx)) != 0) {
+	if ((rv = nni_idhash_alloc32(&ctx_hash, &ctx->c_id, ctx)) != 0) {
 		nni_mtx_unlock(&sock_lk);
 		nni_free(ctx, ctx->c_size);
 		return (rv);
 	}
 
 	if ((rv = sock->s_ctx_ops.ctx_init(ctx->c_data, sock->s_data)) != 0) {
-		nni_idhash_remove(ctx_hash, ctx->c_id);
+		nni_idhash_remove(&ctx_hash, ctx->c_id);
 		nni_mtx_unlock(&sock_lk);
 		nni_free(ctx, ctx->c_size);
 		return (rv);
@@ -1396,7 +1388,7 @@ dialer_timer_start_locked(nni_dialer *d)
 	// This algorithm may lead to slight biases because we don't
 	// have a statistically perfect distribution with the modulo of
 	// the random number, but this really doesn't matter.
-	nni_sleep_aio(back_off ? nni_random() % back_off : 0, d->d_tmo_aio);
+	nni_sleep_aio(back_off ? nni_random() % back_off : 0, &d->d_tmo_aio);
 }
 
 void
@@ -1460,8 +1452,8 @@ dialer_shutdown_impl(nni_dialer *d)
 	nni_pipe *p;
 
 	// Abort any remaining in-flight operations.
-	nni_aio_close(d->d_con_aio);
-	nni_aio_close(d->d_tmo_aio);
+	nni_aio_close(&d->d_con_aio);
+	nni_aio_close(&d->d_tmo_aio);
 
 	// Stop the underlying transport.
 	d->d_ops.d_close(d->d_data);
@@ -1494,8 +1486,8 @@ nni_dialer_reap(nni_dialer *d)
 {
 	nni_sock *s = d->d_sock;
 
-	nni_aio_stop(d->d_tmo_aio);
-	nni_aio_stop(d->d_con_aio);
+	nni_aio_stop(&d->d_tmo_aio);
+	nni_aio_stop(&d->d_con_aio);
 
 	nni_stat_unregister(&d->d_stats.s_root);
 
@@ -1571,8 +1563,8 @@ listener_shutdown_impl(nni_listener *l)
 	nni_pipe *p;
 
 	// Abort any remaining in-flight accepts.
-	nni_aio_close(l->l_acc_aio);
-	nni_aio_close(l->l_tmo_aio);
+	nni_aio_close(&l->l_acc_aio);
+	nni_aio_close(&l->l_tmo_aio);
 
 	// Stop the underlying transport.
 	l->l_ops.l_close(l->l_data);
@@ -1606,8 +1598,8 @@ nni_listener_reap(nni_listener *l)
 {
 	nni_sock *s = l->l_sock;
 
-	nni_aio_stop(l->l_tmo_aio);
-	nni_aio_stop(l->l_acc_aio);
+	nni_aio_stop(&l->l_tmo_aio);
+	nni_aio_stop(&l->l_acc_aio);
 
 	nni_stat_unregister(&l->l_stats.s_root);
 
diff --git a/src/core/sockimpl.h b/src/core/sockimpl.h
index 16596c63..732e2285 100644
--- a/src/core/sockimpl.h
+++ b/src/core/sockimpl.h
@@ -50,8 +50,8 @@ struct nni_dialer {
 	nni_mtx             d_mtx;
 	nni_list            d_pipes;
 	nni_aio *           d_user_aio;
-	nni_aio *           d_con_aio;
-	nni_aio *           d_tmo_aio;  // backoff timer
+	nni_aio             d_con_aio;
+	nni_aio             d_tmo_aio;  // backoff timer
 	nni_duration        d_maxrtime; // maximum time for reconnect
 	nni_duration        d_currtime; // current time for reconnect
 	nni_duration        d_inirtime; // initial time for reconnect
@@ -91,8 +91,8 @@ struct nni_listener {
 	bool                  l_closing; // close started (shutdown)
 	nni_atomic_flag       l_started;
 	nni_list              l_pipes;
-	nni_aio *             l_acc_aio;
-	nni_aio *             l_tmo_aio;
+	nni_aio               l_acc_aio;
+	nni_aio               l_tmo_aio;
 	nni_reap_item         l_reap;
 	nni_listener_stats    l_stats;
 };
diff --git a/src/protocol/pair1/pair.c b/src/protocol/pair1/pair.c
index 00959a4c..6086db7b 100644
--- a/src/protocol/pair1/pair.c
+++ b/src/protocol/pair1/pair.c
@@ -34,7 +34,7 @@ struct pair1_sock {
 	bool           raw;
 	nni_atomic_int ttl;
 	nni_mtx        mtx;
-	nni_idhash *   pipes;
+	nni_idhash     pipes;
 	nni_list       plist;
 	bool           started;
 	nni_stat_item  stat_poly;
@@ -66,7 +66,7 @@ pair1_sock_fini(void *arg)
 {
 	pair1_sock *s = arg;
 
-	nni_idhash_fini(s->pipes);
+	nni_idhash_fini_inline(&s->pipes);
 	nni_mtx_fini(&s->mtx);
 }
 
@@ -75,9 +75,7 @@ pair1_sock_init_impl(void *arg, nni_sock *sock, bool raw)
 {
 	pair1_sock *s = arg;
 
-	if (nni_idhash_init(&s->pipes) != 0) {
-		return (NNG_ENOMEM);
-	}
+	nni_idhash_init_inline(&s->pipes);
 	NNI_LIST_INIT(&s->plist, pair1_pipe, node);
 
 	// Raw mode uses this.
@@ -199,12 +197,12 @@ pair1_pipe_start(void *arg)
 	}
 
 	id = nni_pipe_id(p->pipe);
-	if ((rv = nni_idhash_insert(s->pipes, id, p)) != 0) {
+	if ((rv = nni_idhash_insert(&s->pipes, id, p)) != 0) {
 		nni_mtx_unlock(&s->mtx);
 		return (rv);
 	}
 	if (!nni_list_empty(&s->plist)) {
-		nni_idhash_remove(s->pipes, id);
+		nni_idhash_remove(&s->pipes, id);
 		nni_mtx_unlock(&s->mtx);
 		BUMP_STAT(&s->stat_reject_already);
 		return (NNG_EBUSY);
@@ -234,7 +232,7 @@ pair1_pipe_close(void *arg)
 	nni_aio_close(&p->aio_get);
 
 	nni_mtx_lock(&s->mtx);
-	nni_idhash_remove(s->pipes, nni_pipe_id(p->pipe));
+	nni_idhash_remove(&s->pipes, nni_pipe_id(p->pipe));
 	nni_list_node_remove(&p->node);
 	nni_mtx_unlock(&s->mtx);
 }
@@ -400,7 +398,6 @@ pair1_sock_get_max_ttl(void *arg, void *buf, size_t *szp, nni_opt_type t)
 	return (nni_copyout_int(nni_atomic_get(&s->ttl), buf, szp, t));
 }
 
-
 #ifdef NNG_TEST_LIB
 static int
 pair1_set_test_inject_header(void *arg, const void *buf, size_t sz, nni_type t)
diff --git a/src/protocol/pair1/pair1_poly.c b/src/protocol/pair1/pair1_poly.c
index 950c60f7..0d220d0d 100644
--- a/src/protocol/pair1/pair1_poly.c
+++ b/src/protocol/pair1/pair1_poly.c
@@ -40,7 +40,7 @@ struct pair1poly_sock {
 	nni_sock *     sock;
 	nni_atomic_int ttl;
 	nni_mtx        mtx;
-	nni_idhash *   pipes;
+	nni_idhash     pipes;
 	nni_list       plist;
 	bool           started;
 	nni_aio        aio_get;
@@ -72,7 +72,7 @@ pair1poly_sock_fini(void *arg)
 	pair1poly_sock *s = arg;
 
 	nni_aio_fini(&s->aio_get);
-	nni_idhash_fini(s->pipes);
+	nni_idhash_fini_inline(&s->pipes);
 	nni_mtx_fini(&s->mtx);
 }
 
@@ -81,9 +81,7 @@ pair1poly_sock_init(void *arg, nni_sock *sock)
 {
 	pair1poly_sock *s = arg;
 
-	if (nni_idhash_init(&s->pipes) != 0) {
-		return (NNG_ENOMEM);
-	}
+	nni_idhash_init_inline(&s->pipes);
 	NNI_LIST_INIT(&s->plist, pair1poly_pipe, node);
 
 	// Raw mode uses this.
@@ -196,7 +194,7 @@ pair1poly_pipe_start(void *arg)
 	}
 
 	id = nni_pipe_id(p->pipe);
-	if ((rv = nni_idhash_insert(s->pipes, id, p)) != 0) {
+	if ((rv = nni_idhash_insert(&s->pipes, id, p)) != 0) {
 		nni_mtx_unlock(&s->mtx);
 		return (rv);
 	}
@@ -231,7 +229,7 @@ pair1poly_pipe_close(void *arg)
 	nni_aio_close(&p->aio_get);
 
 	nni_mtx_lock(&s->mtx);
-	nni_idhash_remove(s->pipes, nni_pipe_id(p->pipe));
+	nni_idhash_remove(&s->pipes, nni_pipe_id(p->pipe));
 	nni_list_node_remove(&p->node);
 	nni_mtx_unlock(&s->mtx);
 
@@ -311,7 +309,7 @@ pair1poly_sock_get_cb(void *arg)
 	    (!nni_list_empty(&s->plist))) {
 		p = nni_list_first(&s->plist);
 	} else {
-		nni_idhash_find(s->pipes, id, (void **) &p);
+		nni_idhash_find(&s->pipes, id, (void **) &p);
 	}
 
 	// Try a non-blocking send.  If this fails we just discard the
diff --git a/src/protocol/reqrep0/rep.c b/src/protocol/reqrep0/rep.c
index e750ef56..68ff4266 100644
--- a/src/protocol/reqrep0/rep.c
+++ b/src/protocol/reqrep0/rep.c
@@ -41,7 +41,7 @@ struct rep0_ctx {
 struct rep0_sock {
 	nni_mtx        lk;
 	nni_atomic_int ttl;
-	nni_idhash *   pipes;
+	nni_idhash     pipes;
 	nni_list       recvpipes; // list of pipes with data to receive
 	nni_list       recvq;
 	rep0_ctx       ctx;
@@ -177,7 +177,7 @@ rep0_ctx_send(void *arg, nni_aio *aio)
 		nni_aio_finish_error(aio, rv);
 		return;
 	}
-	if (nni_idhash_find(s->pipes, p_id, (void **) &p) != 0) {
+	if (nni_idhash_find(&s->pipes, p_id, (void **) &p) != 0) {
 		// Pipe is gone.  Make this look like a good send to avoid
 		// disrupting the state machine.  We don't care if the peer
 		// lost interest in our reply.
@@ -210,7 +210,7 @@ rep0_sock_fini(void *arg)
 {
 	rep0_sock *s = arg;
 
-	nni_idhash_fini(s->pipes);
+	nni_idhash_fini_inline(&s->pipes);
 	rep0_ctx_fini(&s->ctx);
 	nni_pollable_fini(&s->writable);
 	nni_pollable_fini(&s->readable);
@@ -221,16 +221,11 @@ static int
 rep0_sock_init(void *arg, nni_sock *sock)
 {
 	rep0_sock *s = arg;
-	int        rv;
 
 	NNI_ARG_UNUSED(sock);
 
 	nni_mtx_init(&s->lk);
-	if ((rv = nni_idhash_init(&s->pipes)) != 0) {
-		rep0_sock_fini(s);
-		return (rv);
-	}
-
+	nni_idhash_init_inline(&s->pipes);
 	NNI_LIST_INIT(&s->recvq, rep0_ctx, rqnode);
 	NNI_LIST_INIT(&s->recvpipes, rep0_pipe, rnode);
 	nni_atomic_init(&s->ttl);
@@ -312,7 +307,10 @@ rep0_pipe_start(void *arg)
 		return (NNG_EPROTO);
 	}
 
-	if ((rv = nni_idhash_insert(s->pipes, nni_pipe_id(p->pipe), p)) != 0) {
+	nni_mtx_lock(&s->lk);
+        rv = nni_idhash_insert(&s->pipes, nni_pipe_id(p->pipe), p);
+	nni_mtx_unlock(&s->lk);
+	if (rv != 0) {
 		return (rv);
 	}
 	// By definition, we have not received a request yet on this pipe,
@@ -355,7 +353,7 @@ rep0_pipe_close(void *arg)
 		// accept a message and discard it.)
 		nni_pollable_raise(&s->writable);
 	}
-	nni_idhash_remove(s->pipes, nni_pipe_id(p->pipe));
+	nni_idhash_remove(&s->pipes, nni_pipe_id(p->pipe));
 	nni_mtx_unlock(&s->lk);
 }
 
diff --git a/src/protocol/reqrep0/req.c b/src/protocol/reqrep0/req.c
index 0112f835..f01c4427 100644
--- a/src/protocol/reqrep0/req.c
+++ b/src/protocol/reqrep0/req.c
@@ -55,7 +55,7 @@ struct req0_sock {
 	nni_list       stop_pipes;
 	nni_list       contexts;
 	nni_list       send_queue; // contexts waiting to send.
-	nni_idhash *   requests;   // contexts by request ID
+	nni_idhash     requests;   // contexts by request ID
 	nni_pollable   readable;
 	nni_pollable   writable;
 	nni_mtx        mtx;
@@ -80,19 +80,16 @@ static int
 req0_sock_init(void *arg, nni_sock *sock)
 {
 	req0_sock *s = arg;
-	int        rv;
 
 	NNI_ARG_UNUSED(sock);
 
-	if ((rv = nni_idhash_init(&s->requests)) != 0) {
-		return (rv);
-	}
+	nni_idhash_init_inline(&s->requests);
 
 	// Request IDs are 32 bits, with the high order bit set.
 	// We start at a random point, to minimize likelihood of
 	// accidental collision across restarts.
 	nni_idhash_set_limits(
-	    s->requests, 0x80000000u, 0xffffffffu, nni_random() | 0x80000000u);
+	    &s->requests, 0x80000000u, 0xffffffffu, nni_random() | 0x80000000u);
 
 	nni_mtx_init(&s->mtx);
 
@@ -145,7 +142,7 @@ req0_sock_fini(void *arg)
 	req0_ctx_fini(&s->master);
 	nni_pollable_fini(&s->readable);
 	nni_pollable_fini(&s->writable);
-	nni_idhash_fini(s->requests);
+	nni_idhash_fini_inline(&s->requests);
 	nni_mtx_fini(&s->mtx);
 }
 
@@ -316,7 +313,7 @@ req0_recv_cb(void *arg)
 	nni_pipe_recv(p->pipe, &p->aio_recv);
 
 	// Look for a context to receive it.
-	if ((nni_idhash_find(s->requests, id, (void **) &ctx) != 0) ||
+	if ((nni_idhash_find(&s->requests, id, (void **) &ctx) != 0) ||
 	    (ctx->send_aio != NULL) || (ctx->rep_msg != NULL)) {
 		nni_mtx_unlock(&s->mtx);
 		// No waiting context, we have not sent the request out to
@@ -328,7 +325,7 @@ req0_recv_cb(void *arg)
 
 	// We have our match, so we can remove this.
 	nni_list_node_remove(&ctx->send_node);
-	nni_idhash_remove(s->requests, id);
+	nni_idhash_remove(&s->requests, id);
 	ctx->request_id = 0;
 	if (ctx->req_msg != NULL) {
 		nni_msg_free(ctx->req_msg);
@@ -512,7 +509,7 @@ req0_ctx_reset(req0_ctx *ctx)
 	nni_list_node_remove(&ctx->pipe_node);
 	nni_list_node_remove(&ctx->send_node);
 	if (ctx->request_id != 0) {
-		nni_idhash_remove(s->requests, ctx->request_id);
+		nni_idhash_remove(&s->requests, ctx->request_id);
 		ctx->request_id = 0;
 	}
 	if (ctx->req_msg != NULL) {
@@ -662,7 +659,7 @@ req0_ctx_send(void *arg, nni_aio *aio)
 	req0_ctx_reset(ctx);
 
 	// Insert us on the per ID hash list, so that receives can find us.
-	if ((rv = nni_idhash_alloc(s->requests, &id, ctx)) != 0) {
+	if ((rv = nni_idhash_alloc(&s->requests, &id, ctx)) != 0) {
 		nni_mtx_unlock(&s->mtx);
 		nni_aio_finish_error(aio, rv);
 		return;
@@ -675,7 +672,7 @@ req0_ctx_send(void *arg, nni_aio *aio)
 	// schedule), then fail it.  Should be NNG_ETIMEDOUT.
 	rv = nni_aio_schedule(aio, req0_ctx_cancel_send, ctx);
 	if ((rv != 0) && (nni_list_empty(&s->ready_pipes))) {
-		nni_idhash_remove(s->requests, id);
+		nni_idhash_remove(&s->requests, id);
 		nni_mtx_unlock(&s->mtx);
 		nni_aio_finish_error(aio, rv);
 		return;
diff --git a/src/protocol/reqrep0/xrep.c b/src/protocol/reqrep0/xrep.c
index 0bce27ba..8400c127 100644
--- a/src/protocol/reqrep0/xrep.c
+++ b/src/protocol/reqrep0/xrep.c
@@ -33,7 +33,7 @@ struct xrep0_sock {
 	nni_msgq *     urq;
 	nni_mtx        lk;
 	nni_atomic_int ttl;
-	nni_idhash *   pipes;
+	nni_idhash     pipes;
 	nni_aio        aio_getq;
 };
 
@@ -54,7 +54,7 @@ xrep0_sock_fini(void *arg)
 	xrep0_sock *s = arg;
 
 	nni_aio_fini(&s->aio_getq);
-	nni_idhash_fini(s->pipes);
+	nni_idhash_fini_inline(&s->pipes);
 	nni_mtx_fini(&s->lk);
 }
 
@@ -62,7 +62,6 @@ static int
 xrep0_sock_init(void *arg, nni_sock *sock)
 {
 	xrep0_sock *s = arg;
-	int         rv;
 
 	nni_mtx_init(&s->lk);
 	nni_aio_init(&s->aio_getq, xrep0_sock_getq_cb, s);
@@ -71,11 +70,7 @@ xrep0_sock_init(void *arg, nni_sock *sock)
 	s->uwq = nni_sock_sendq(sock);
 	s->urq = nni_sock_recvq(sock);
 
-	if ((rv = nni_idhash_init(&s->pipes)) != 0) {
-		xrep0_sock_fini(s);
-		return (rv);
-	}
-
+	nni_idhash_init_inline(&s->pipes);
 	return (0);
 }
 
@@ -164,7 +159,10 @@ xrep0_pipe_start(void *arg)
 		return (NNG_EPROTO);
 	}
 
-	if ((rv = nni_idhash_insert(s->pipes, nni_pipe_id(p->pipe), p)) != 0) {
+	nni_mtx_lock(&s->lk);
+	rv = nni_idhash_insert(&s->pipes, nni_pipe_id(p->pipe), p);
+	nni_mtx_unlock(&s->lk);
+	if (rv != 0) {
 		return (rv);
 	}
 
@@ -186,7 +184,7 @@ xrep0_pipe_close(void *arg)
 	nni_msgq_close(p->sendq);
 
 	nni_mtx_lock(&s->lk);
-	nni_idhash_remove(s->pipes, nni_pipe_id(p->pipe));
+	nni_idhash_remove(&s->pipes, nni_pipe_id(p->pipe));
 	nni_mtx_unlock(&s->lk);
 }
 
@@ -227,7 +225,7 @@ xrep0_sock_getq_cb(void *arg)
 	// (non-blocking) if we can.  If we can't for any reason, then we
 	// free the message.
 	nni_mtx_lock(&s->lk);
-	if (((nni_idhash_find(s->pipes, id, (void **) &p)) != 0) ||
+	if (((nni_idhash_find(&s->pipes, id, (void **) &p)) != 0) ||
 	    (nni_msgq_tryput(p->sendq, msg) != 0)) {
 		nni_msg_free(msg);
 	}
diff --git a/src/protocol/survey0/respond.c b/src/protocol/survey0/respond.c
index b414c189..4cd00759 100644
--- a/src/protocol/survey0/respond.c
+++ b/src/protocol/survey0/respond.c
@@ -50,7 +50,7 @@ struct resp0_ctx {
 struct resp0_sock {
 	nni_mtx        mtx;
 	nni_atomic_int ttl;
-	nni_idhash *   pipes;
+	nni_idhash     pipes;
 	resp0_ctx      ctx;
 	nni_list       recvpipes;
 	nni_list       recvq;
@@ -181,7 +181,7 @@ resp0_ctx_send(void *arg, nni_aio *aio)
 		return;
 	}
 
-	if (nni_idhash_find(s->pipes, pid, (void **) &p) != 0) {
+	if (nni_idhash_find(&s->pipes, pid, (void **) &p) != 0) {
 		// Surveyor has left the building.  Just discard the reply.
 		nni_mtx_unlock(&s->mtx);
 		nni_aio_set_msg(aio, NULL);
@@ -213,7 +213,7 @@ resp0_sock_fini(void *arg)
 {
 	resp0_sock *s = arg;
 
-	nni_idhash_fini(s->pipes);
+	nni_idhash_fini_inline(&s->pipes);
 	resp0_ctx_fini(&s->ctx);
 	nni_pollable_fini(&s->writable);
 	nni_pollable_fini(&s->readable);
@@ -224,15 +224,11 @@ static int
 resp0_sock_init(void *arg, nni_sock *nsock)
 {
 	resp0_sock *s = arg;
-	int         rv;
 
 	NNI_ARG_UNUSED(nsock);
 
 	nni_mtx_init(&s->mtx);
-	if ((rv = nni_idhash_init(&s->pipes)) != 0) {
-		resp0_sock_fini(s);
-		return (rv);
-	}
+	nni_idhash_init_inline(&s->pipes);
 
 	NNI_LIST_INIT(&s->recvq, resp0_ctx, rqnode);
 	NNI_LIST_INIT(&s->recvpipes, resp0_pipe, rnode);
@@ -316,7 +312,7 @@ resp0_pipe_start(void *arg)
 	}
 
 	nni_mtx_lock(&s->mtx);
-	rv = nni_idhash_insert(s->pipes, p->id, p);
+	rv = nni_idhash_insert(&s->pipes, p->id, p);
 	nni_mtx_unlock(&s->mtx);
 	if (rv != 0) {
 		return (rv);
@@ -354,7 +350,7 @@ resp0_pipe_close(void *arg)
 		// which we will happily discard.
 		nni_pollable_raise(&s->writable);
 	}
-	nni_idhash_remove(s->pipes, p->id);
+	nni_idhash_remove(&s->pipes, p->id);
 	nni_mtx_unlock(&s->mtx);
 }
 
diff --git a/src/protocol/survey0/survey.c b/src/protocol/survey0/survey.c
index e4cdca2c..6310ce6c 100644
--- a/src/protocol/survey0/survey.c
+++ b/src/protocol/survey0/survey.c
@@ -45,7 +45,7 @@ struct surv0_sock {
 	nni_list       pipes;
 	nni_mtx        mtx;
 	surv0_ctx      ctx;
-	nni_idhash *   surveys;
+	nni_idhash     surveys;
 	nni_pollable   writable;
 	nni_pollable   readable;
 	nni_atomic_int send_buf;
@@ -57,8 +57,8 @@ struct surv0_pipe {
 	surv0_sock *  sock;
 	nni_lmq       send_queue;
 	nni_list_node node;
-	nni_aio *     aio_send;
-	nni_aio *     aio_recv;
+	nni_aio       aio_send;
+	nni_aio       aio_recv;
 	bool          busy;
 	bool          closed;
 };
@@ -75,7 +75,7 @@ surv0_ctx_abort(surv0_ctx *ctx, int err)
 	}
 	nni_lmq_flush(&ctx->recv_lmq);
 	if (ctx->survey_id != 0) {
-		nni_idhash_remove(sock->surveys, ctx->survey_id);
+		nni_idhash_remove(&sock->surveys, ctx->survey_id);
 		ctx->survey_id = 0;
 	}
 	if (ctx == &sock->ctx) {
@@ -148,7 +148,7 @@ surv0_ctx_cancel(nni_aio *aio, void *arg, int rv)
 		nni_aio_finish_error(aio, rv);
 	}
 	if (ctx->survey_id != 0) {
-		nni_idhash_remove(sock->surveys, ctx->survey_id);
+		nni_idhash_remove(&sock->surveys, ctx->survey_id);
 		ctx->survey_id = 0;
 	}
 	nni_mtx_unlock(&sock->mtx);
@@ -237,7 +237,7 @@ surv0_ctx_send(void *arg, nni_aio *aio)
 	nni_timer_cancel(&ctx->timer);
 
 	// Allocate the new ID.
-	if ((rv = nni_idhash_alloc(sock->surveys, &ctx->survey_id, ctx)) !=
+	if ((rv = nni_idhash_alloc(&sock->surveys, &ctx->survey_id, ctx)) !=
 	    0) {
 		nni_mtx_unlock(&sock->mtx);
 		nni_aio_finish_error(aio, rv);
@@ -256,8 +256,8 @@ surv0_ctx_send(void *arg, nni_aio *aio)
 		if (!pipe->busy) {
 			pipe->busy = true;
 			nni_msg_clone(msg);
-			nni_aio_set_msg(pipe->aio_send, msg);
-			nni_pipe_send(pipe->pipe, pipe->aio_send);
+			nni_aio_set_msg(&pipe->aio_send, msg);
+			nni_pipe_send(pipe->pipe, &pipe->aio_send);
 		} else if (!nni_lmq_full(&pipe->send_queue)) {
 			nni_msg_clone(msg);
 			nni_lmq_putq(&pipe->send_queue, msg);
@@ -279,7 +279,7 @@ surv0_sock_fini(void *arg)
 	surv0_sock *sock = arg;
 
 	surv0_ctx_fini(&sock->ctx);
-	nni_idhash_fini(sock->surveys);
+	nni_idhash_fini_inline(&sock->surveys);
 	nni_pollable_fini(&sock->writable);
 	nni_pollable_fini(&sock->readable);
 	nni_mtx_fini(&sock->mtx);
@@ -306,9 +306,9 @@ surv0_sock_init(void *arg, nni_sock *s)
 	// at nearly the same time.
 	nni_atomic_init(&sock->send_buf);
 	nni_atomic_set(&sock->send_buf, 8);
+	nni_idhash_init_inline(&sock->surveys);
 
-	if (((rv = nni_idhash_init(&sock->surveys)) != 0) ||
-	    ((rv = surv0_ctx_init(&sock->ctx, sock)) != 0)) {
+	if ((rv = surv0_ctx_init(&sock->ctx, sock)) != 0) {
 		surv0_sock_fini(sock);
 		return (rv);
 	}
@@ -316,7 +316,7 @@ surv0_sock_init(void *arg, nni_sock *s)
 	// Survey IDs are 32 bits, with the high order bit set.
 	// We start at a random point, to minimize likelihood of
 	// accidental collision across restarts.
-	nni_idhash_set_limits(sock->surveys, 0x80000000u, 0xffffffffu,
+	nni_idhash_set_limits(&sock->surveys, 0x80000000u, 0xffffffffu,
 	    nni_random() | 0x80000000u);
 
 	sock->ttl = 8;
@@ -343,8 +343,8 @@ surv0_pipe_stop(void *arg)
 {
 	surv0_pipe *p = arg;
 
-	nni_aio_stop(p->aio_send);
-	nni_aio_stop(p->aio_recv);
+	nni_aio_stop(&p->aio_send);
+	nni_aio_stop(&p->aio_recv);
 }
 
 static void
@@ -352,8 +352,8 @@ surv0_pipe_fini(void *arg)
 {
 	surv0_pipe *p = arg;
 
-	nni_aio_free(p->aio_send);
-	nni_aio_free(p->aio_recv);
+	nni_aio_fini(&p->aio_send);
+	nni_aio_fini(&p->aio_recv);
 	nni_lmq_fini(&p->send_queue);
 }
 
@@ -366,13 +366,13 @@ surv0_pipe_init(void *arg, nni_pipe *pipe, void *s)
 	int         len;
 
 	len = nni_atomic_get(&sock->send_buf);
+	nni_aio_init(&p->aio_send, surv0_pipe_send_cb, p);
+	nni_aio_init(&p->aio_recv, surv0_pipe_recv_cb, p);
 
 	// This depth could be tunable.  The deeper the queue, the more
 	// concurrent surveys that can be delivered (multiple contexts).
 	// Note that surveys can be *outstanding*, but not yet put on the wire.
-	if (((rv = nni_lmq_init(&p->send_queue, len)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_send, surv0_pipe_send_cb, p)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_recv, surv0_pipe_recv_cb, p)) != 0)) {
+	if ((rv = nni_lmq_init(&p->send_queue, len)) != 0) {
 		surv0_pipe_fini(p);
 		return (rv);
 	}
@@ -396,7 +396,7 @@ surv0_pipe_start(void *arg)
 	nni_list_append(&s->pipes, p);
 	nni_mtx_unlock(&s->mtx);
 
-	nni_pipe_recv(p->pipe, p->aio_recv);
+	nni_pipe_recv(p->pipe, &p->aio_recv);
 	return (0);
 }
 
@@ -406,8 +406,8 @@ surv0_pipe_close(void *arg)
 	surv0_pipe *p = arg;
 	surv0_sock *s = p->sock;
 
-	nni_aio_close(p->aio_send);
-	nni_aio_close(p->aio_recv);
+	nni_aio_close(&p->aio_send);
+	nni_aio_close(&p->aio_recv);
 
 	nni_mtx_lock(&s->mtx);
 	p->closed = true;
@@ -425,9 +425,9 @@ surv0_pipe_send_cb(void *arg)
 	surv0_sock *sock = p->sock;
 	nni_msg *   msg;
 
-	if (nni_aio_result(p->aio_send) != 0) {
-		nni_msg_free(nni_aio_get_msg(p->aio_send));
-		nni_aio_set_msg(p->aio_send, NULL);
+	if (nni_aio_result(&p->aio_send) != 0) {
+		nni_msg_free(nni_aio_get_msg(&p->aio_send));
+		nni_aio_set_msg(&p->aio_send, NULL);
 		nni_pipe_close(p->pipe);
 		return;
 	}
@@ -438,8 +438,8 @@ surv0_pipe_send_cb(void *arg)
 		return;
 	}
 	if (nni_lmq_getq(&p->send_queue, &msg) == 0) {
-		nni_aio_set_msg(p->aio_send, msg);
-		nni_pipe_send(p->pipe, p->aio_send);
+		nni_aio_set_msg(&p->aio_send, msg);
+		nni_pipe_send(p->pipe, &p->aio_send);
 	} else {
 		p->busy = false;
 	}
@@ -456,13 +456,13 @@ surv0_pipe_recv_cb(void *arg)
 	uint32_t    id;
 	nni_aio *   aio;
 
-	if (nni_aio_result(p->aio_recv) != 0) {
+	if (nni_aio_result(&p->aio_recv) != 0) {
 		nni_pipe_close(p->pipe);
 		return;
 	}
 
-	msg = nni_aio_get_msg(p->aio_recv);
-	nni_aio_set_msg(p->aio_recv, NULL);
+	msg = nni_aio_get_msg(&p->aio_recv);
+	nni_aio_set_msg(&p->aio_recv, NULL);
 	nni_msg_set_pipe(msg, nni_pipe_id(p->pipe));
 
 	// We yank 4 bytes of body, and move them to the header.
@@ -478,7 +478,7 @@ surv0_pipe_recv_cb(void *arg)
 	nni_mtx_lock(&sock->mtx);
 	// Best effort at delivery.  Discard if no context or context is
 	// unable to receive it.
-	if ((nni_idhash_find(sock->surveys, id, (void **) &ctx) != 0) ||
+	if ((nni_idhash_find(&sock->surveys, id, (void **) &ctx) != 0) ||
 	    (nni_lmq_full(&ctx->recv_lmq))) {
 		nni_msg_free(msg);
 	} else if ((aio = nni_list_first(&ctx->recv_queue)) != NULL) {
@@ -492,7 +492,7 @@ surv0_pipe_recv_cb(void *arg)
 	}
 	nni_mtx_unlock(&sock->mtx);
 
-	nni_pipe_recv(p->pipe, p->aio_recv);
+	nni_pipe_recv(p->pipe, &p->aio_recv);
 }
 
 static int
diff --git a/src/protocol/survey0/xrespond.c b/src/protocol/survey0/xrespond.c
index 25aacc2c..846af84f 100644
--- a/src/protocol/survey0/xrespond.c
+++ b/src/protocol/survey0/xrespond.c
@@ -40,8 +40,8 @@ struct xresp0_sock {
 	nni_msgq *     urq;
 	nni_msgq *     uwq;
 	nni_atomic_int ttl;
-	nni_idhash *   pipes;
-	nni_aio *      aio_getq;
+	nni_idhash     pipes;
+	nni_aio        aio_getq;
 	nni_mtx        mtx;
 };
 
@@ -51,10 +51,10 @@ struct xresp0_pipe {
 	xresp0_sock *psock;
 	uint32_t     id;
 	nni_msgq *   sendq;
-	nni_aio *    aio_getq;
-	nni_aio *    aio_putq;
-	nni_aio *    aio_send;
-	nni_aio *    aio_recv;
+	nni_aio      aio_getq;
+	nni_aio      aio_putq;
+	nni_aio      aio_send;
+	nni_aio      aio_recv;
 };
 
 static void
@@ -62,8 +62,8 @@ xresp0_sock_fini(void *arg)
 {
 	xresp0_sock *s = arg;
 
-	nni_aio_free(s->aio_getq);
-	nni_idhash_fini(s->pipes);
+	nni_aio_fini(&s->aio_getq);
+	nni_idhash_fini_inline(&s->pipes);
 	nni_mtx_fini(&s->mtx);
 }
 
@@ -71,17 +71,12 @@ static int
 xresp0_sock_init(void *arg, nni_sock *nsock)
 {
 	xresp0_sock *s = arg;
-	int          rv;
 
 	nni_mtx_init(&s->mtx);
 	nni_atomic_init(&s->ttl);
 	nni_atomic_set(&s->ttl, 8); // Per RFC
-	if (((rv = nni_idhash_init(&s->pipes)) != 0) ||
-	    ((rv = nni_aio_alloc(&s->aio_getq, xresp0_sock_getq_cb, s)) !=
-	        0)) {
-		xresp0_sock_fini(s);
-		return (rv);
-	}
+	nni_idhash_init_inline(&s->pipes);
+	nni_aio_init(&s->aio_getq, xresp0_sock_getq_cb, s);
 
 	s->urq = nni_sock_recvq(nsock);
 	s->uwq = nni_sock_sendq(nsock);
@@ -94,7 +89,7 @@ xresp0_sock_open(void *arg)
 {
 	xresp0_sock *s = arg;
 
-	nni_msgq_aio_get(s->uwq, s->aio_getq);
+	nni_msgq_aio_get(s->uwq, &s->aio_getq);
 }
 
 static void
@@ -102,7 +97,7 @@ xresp0_sock_close(void *arg)
 {
 	xresp0_sock *s = arg;
 
-	nni_aio_close(s->aio_getq);
+	nni_aio_close(&s->aio_getq);
 }
 
 static void
@@ -110,10 +105,10 @@ xresp0_pipe_stop(void *arg)
 {
 	xresp0_pipe *p = arg;
 
-	nni_aio_stop(p->aio_putq);
-	nni_aio_stop(p->aio_getq);
-	nni_aio_stop(p->aio_send);
-	nni_aio_stop(p->aio_recv);
+	nni_aio_stop(&p->aio_putq);
+	nni_aio_stop(&p->aio_getq);
+	nni_aio_stop(&p->aio_send);
+	nni_aio_stop(&p->aio_recv);
 }
 
 static void
@@ -121,10 +116,10 @@ xresp0_pipe_fini(void *arg)
 {
 	xresp0_pipe *p = arg;
 
-	nni_aio_free(p->aio_putq);
-	nni_aio_free(p->aio_getq);
-	nni_aio_free(p->aio_send);
-	nni_aio_free(p->aio_recv);
+	nni_aio_fini(&p->aio_putq);
+	nni_aio_fini(&p->aio_getq);
+	nni_aio_fini(&p->aio_send);
+	nni_aio_fini(&p->aio_recv);
 	nni_msgq_fini(p->sendq);
 }
 
@@ -134,11 +129,12 @@ xresp0_pipe_init(void *arg, nni_pipe *npipe, void *s)
 	xresp0_pipe *p = arg;
 	int          rv;
 
-	if (((rv = nni_msgq_init(&p->sendq, 2)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_putq, xresp0_putq_cb, p)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_recv, xresp0_recv_cb, p)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_getq, xresp0_getq_cb, p)) != 0) ||
-	    ((rv = nni_aio_alloc(&p->aio_send, xresp0_send_cb, p)) != 0)) {
+	nni_aio_init(&p->aio_putq, xresp0_putq_cb, p);
+	nni_aio_init(&p->aio_recv, xresp0_recv_cb, p);
+	nni_aio_init(&p->aio_getq, xresp0_getq_cb, p);
+	nni_aio_init(&p->aio_send, xresp0_send_cb, p);
+
+	if ((rv = nni_msgq_init(&p->sendq, 2)) != 0) {
 		xresp0_pipe_fini(p);
 		return (rv);
 	}
@@ -162,14 +158,14 @@ xresp0_pipe_start(void *arg)
 	p->id = nni_pipe_id(p->npipe);
 
 	nni_mtx_lock(&s->mtx);
-	rv = nni_idhash_insert(s->pipes, p->id, p);
+	rv = nni_idhash_insert(&s->pipes, p->id, p);
 	nni_mtx_unlock(&s->mtx);
 	if (rv != 0) {
 		return (rv);
 	}
 
-	nni_pipe_recv(p->npipe, p->aio_recv);
-	nni_msgq_aio_get(p->sendq, p->aio_getq);
+	nni_pipe_recv(p->npipe, &p->aio_recv);
+	nni_msgq_aio_get(p->sendq, &p->aio_getq);
 
 	return (rv);
 }
@@ -180,15 +176,15 @@ xresp0_pipe_close(void *arg)
 	xresp0_pipe *p = arg;
 	xresp0_sock *s = p->psock;
 
-	nni_aio_close(p->aio_putq);
-	nni_aio_close(p->aio_getq);
-	nni_aio_close(p->aio_send);
-	nni_aio_close(p->aio_recv);
+	nni_aio_close(&p->aio_putq);
+	nni_aio_close(&p->aio_getq);
+	nni_aio_close(&p->aio_send);
+	nni_aio_close(&p->aio_recv);
 
 	nni_msgq_close(p->sendq);
 
 	nni_mtx_lock(&s->mtx);
-	nni_idhash_remove(s->pipes, p->id);
+	nni_idhash_remove(&s->pipes, p->id);
 	nni_mtx_unlock(&s->mtx);
 }
 
@@ -205,17 +201,17 @@ xresp0_sock_getq_cb(void *arg)
 	uint32_t     id;
 	xresp0_pipe *p;
 
-	if (nni_aio_result(s->aio_getq) != 0) {
+	if (nni_aio_result(&s->aio_getq) != 0) {
 		return;
 	}
-	msg = nni_aio_get_msg(s->aio_getq);
-	nni_aio_set_msg(s->aio_getq, NULL);
+	msg = nni_aio_get_msg(&s->aio_getq);
+	nni_aio_set_msg(&s->aio_getq, NULL);
 
 	// We yank the outgoing pipe id from the header
 	if (nni_msg_header_len(msg) < 4) {
 		nni_msg_free(msg);
 		// We can't really close down the socket, so just keep going.
-		nni_msgq_aio_get(s->uwq, s->aio_getq);
+		nni_msgq_aio_get(s->uwq, &s->aio_getq);
 		return;
 	}
 	id = nni_msg_header_trim_u32(msg);
@@ -224,12 +220,12 @@ xresp0_sock_getq_cb(void *arg)
 	// Look for the pipe, and attempt to put the message there
 	// (nonblocking) if we can.  If we can't for any reason, then we
 	// free the message.
-	if (((nni_idhash_find(s->pipes, id, (void **) &p)) != 0) ||
+	if (((nni_idhash_find(&s->pipes, id, (void **) &p)) != 0) ||
 	    (nni_msgq_tryput(p->sendq, msg) != 0)) {
 		nni_msg_free(msg);
 	}
 	nni_mtx_unlock(&s->mtx);
-	nni_msgq_aio_get(s->uwq, s->aio_getq);
+	nni_msgq_aio_get(s->uwq, &s->aio_getq);
 }
 
 void
@@ -237,15 +233,15 @@ xresp0_getq_cb(void *arg)
 {
 	xresp0_pipe *p = arg;
 
-	if (nni_aio_result(p->aio_getq) != 0) {
+	if (nni_aio_result(&p->aio_getq) != 0) {
 		nni_pipe_close(p->npipe);
 		return;
 	}
 
-	nni_aio_set_msg(p->aio_send, nni_aio_get_msg(p->aio_getq));
-	nni_aio_set_msg(p->aio_getq, NULL);
+	nni_aio_set_msg(&p->aio_send, nni_aio_get_msg(&p->aio_getq));
+	nni_aio_set_msg(&p->aio_getq, NULL);
 
-	nni_pipe_send(p->npipe, p->aio_send);
+	nni_pipe_send(p->npipe, &p->aio_send);
 }
 
 void
@@ -253,14 +249,14 @@ xresp0_send_cb(void *arg)
 {
 	xresp0_pipe *p = arg;
 
-	if (nni_aio_result(p->aio_send) != 0) {
-		nni_msg_free(nni_aio_get_msg(p->aio_send));
-		nni_aio_set_msg(p->aio_send, NULL);
+	if (nni_aio_result(&p->aio_send) != 0) {
+		nni_msg_free(nni_aio_get_msg(&p->aio_send));
+		nni_aio_set_msg(&p->aio_send, NULL);
 		nni_pipe_close(p->npipe);
 		return;
 	}
 
-	nni_msgq_aio_get(p->sendq, p->aio_getq);
+	nni_msgq_aio_get(p->sendq, &p->aio_getq);
 }
 
 static void
@@ -273,14 +269,14 @@ xresp0_recv_cb(void *arg)
 	int          hops;
 	int          ttl;
 
-	if (nni_aio_result(p->aio_recv) != 0) {
+	if (nni_aio_result(&p->aio_recv) != 0) {
 		nni_pipe_close(p->npipe);
 		return;
 	}
 
 	ttl = nni_atomic_get(&s->ttl);
-	msg = nni_aio_get_msg(p->aio_recv);
-	nni_aio_set_msg(p->aio_recv, NULL);
+	msg = nni_aio_get_msg(&p->aio_recv);
+	nni_aio_set_msg(&p->aio_recv, NULL);
 	nni_msg_set_pipe(msg, p->id);
 
 	// Store the pipe id in the header, first thing.
@@ -314,13 +310,13 @@ xresp0_recv_cb(void *arg)
 	}
 
 	// Now send it up.
-	nni_aio_set_msg(p->aio_putq, msg);
-	nni_msgq_aio_put(urq, p->aio_putq);
+	nni_aio_set_msg(&p->aio_putq, msg);
+	nni_msgq_aio_put(urq, &p->aio_putq);
 	return;
 
 drop:
 	nni_msg_free(msg);
-	nni_pipe_recv(p->npipe, p->aio_recv);
+	nni_pipe_recv(p->npipe, &p->aio_recv);
 }
 
 static void
@@ -328,22 +324,22 @@ xresp0_putq_cb(void *arg)
 {
 	xresp0_pipe *p = arg;
 
-	if (nni_aio_result(p->aio_putq) != 0) {
-		nni_msg_free(nni_aio_get_msg(p->aio_putq));
-		nni_aio_set_msg(p->aio_putq, NULL);
+	if (nni_aio_result(&p->aio_putq) != 0) {
+		nni_msg_free(nni_aio_get_msg(&p->aio_putq));
+		nni_aio_set_msg(&p->aio_putq, NULL);
 		nni_pipe_close(p->npipe);
 		return;
 	}
 
-	nni_pipe_recv(p->npipe, p->aio_recv);
+	nni_pipe_recv(p->npipe, &p->aio_recv);
 }
 
 static int
 xresp0_sock_set_maxttl(void *arg, const void *buf, size_t sz, nni_opt_type t)
 {
 	xresp0_sock *s = arg;
-	int ttl;
-	int rv;
+	int          ttl;
+	int          rv;
 	if ((rv = nni_copyin_int(&ttl, buf, sz, 1, NNI_MAX_MAX_TTL, t)) == 0) {
 		nni_atomic_set(&s->ttl, ttl);
 	}
